﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Collections;
using System.Web.UI;
using System.Web.UI.WebControls;

public class ColumnGenerator : IAutoFieldGenerator {
    private IEnumerable<string> _columns;
    public ColumnGenerator(IEnumerable<string> columns) {
        _columns = columns ?? Enumerable.Empty<string>();
    }

    public ICollection GenerateFields(Control control) {
        return (from column in _columns
                select new BoundField {
                    SortExpression = column,
                    HeaderText = column,
                    DataField = column
                }).ToArray();
    }
}
