﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.ComponentModel;

public partial class _Default : System.Web.UI.Page {

    private HashSet<string> Columns {
        get {
            var columns = ViewState["Columns"] as HashSet<string>;
            if (columns == null) {
                columns = new HashSet<string>();
                ViewState["Columns"] = columns;
            }
            return columns;
        }
    }

    protected void Page_Load(object sender, EventArgs e) {
        gridView1.ColumnsGenerator = new ColumnGenerator(Columns);

        if (!IsPostBack) {
            BindColumns();
        }
    }

    private void BindColumns() {
        columnSet.DataSource = GetColumns();
        columnSet.DataBind();
    }

    protected void OnColumnSetRowCommand(object sender, GridViewCommandEventArgs e) {
        if (e.CommandName == "Hide") {
            string columnName = (string)e.CommandArgument;
            Columns.Remove(columnName);
            gridView1.DataBind();
            BindColumns();
        }
        else if (e.CommandName == "Show") {
            string columnName = (string)e.CommandArgument;
            Columns.Add(columnName);
            gridView1.DataBind();
            BindColumns();
        }
    }

    protected bool IsShowing(string columnName) {
        return Columns.Contains(columnName);
    }

    private IEnumerable<string> GetColumns() {
        return TypeDescriptor.GetProperties(typeof(Product))
                .OfType<PropertyDescriptor>()
                .Select(p => p.Name);
    }
}
